#ifndef	MBLUR_H
#define MBLUR_H

#ifndef 	USE_MBLUR
half3 	mblur	(half3 pos, half3 c_original)	{ return c_original; }
#else
#include "common.h"

uniform half4x4	m_current;
uniform half4x4	m_previous;
uniform half2 	m_blur;		// scale_x / 12, scale_y / 12

#define MBLUR_SAMPLES 	half(12)
#define MBLUR_CLAMP	half(100.h)

half3 	mblur	(float2 UVQ, half3 pos, half3 c_original)	{
	half4 	pos4		= half4	(pos,0.001h);

	half4 	p_current	= mul	(m_current,	pos4);
	half4 	p_previous 	= mul	(m_previous,	pos4);
	half2 	p_velocity 	= m_blur * ( (p_current.xy/p_current.w)-(p_previous.xy/p_previous.w) );
		p_velocity	= clamp	(p_velocity,-MBLUR_CLAMP,+MBLUR_CLAMP);

	// For each sample, sum up each sample's color in "Blurred" and then divide
	// to average the color after all the samples are added.
	half3 	blurred 	= 	c_original * 12.0 ;	//h	;
		blurred 	+= 	tex2D(s_bloom, p_velocity * 1.h + UVQ).rgb;	// * 2.h;	//1.5h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 3.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 5.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 7.h + UVQ).rgb;	// * 2.h;
        	blurred 	+= 	tex2D(s_bloom, p_velocity * 9.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 11.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 13.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 15.h + UVQ).rgb;	// * 2.h;
		blurred 	+= 	tex2D(s_bloom, p_velocity * 17.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 19.h + UVQ).rgb;	// * 2.h;
		blurred		+= 	tex2D(s_bloom, p_velocity * 21.h + UVQ).rgb;	// * 2.h;
	return 	blurred/MBLUR_SAMPLES;
}
#endif

#endif
